;; 
;;
PRO BODY_MOTION_DIGITAL_FILTER__DEFINE

    ; define the class structure 
    struct = { BODY_MOTION_DIGITAL_FILTER, INHERITS digital_filter }

END


;; Creates new Body Motion Filter.
;;
FUNCTION BODY_MOTION_DIGITAL_FILTER::INIT, SAMPLING_TIME=SAMPLING_TIME, MULTIPLEX_DIMENSION=MULTIPLEX_DIMENSION

    return, self->digital_filter::init(sampling_time=sampling_time, multiplex_dimension=multiplex_dimension, lower_frequency=0.0, upper_frequency=0.1, filter_power=100, terms=100)

END


;; 
;;
PRO BODY_MOTION_DIGITAL_FILTER::CLEANUP

    self->digital_filter::cleanup

END
