;; 
;;
PRO RESPIRATORY_SIGNAL_CORRELATION_COMPARATOR__DEFINE

    ; define the class structure 
    struct = { RESPIRATORY_SIGNAL_CORRELATION_COMPARATOR, INHERITS abstract_respiratory_signal_comparator}

END


;; 
;;
FUNCTION RESPIRATORY_SIGNAL_CORRELATION_COMPARATOR::INIT, DURATION=DURATION

    if (~self->abstract_respiratory_signal_comparator::init(duration=duration)) then begin
        return, 0
    endif

    return, 1

END



;;
;;
PRO RESPIRATORY_SIGNAL_CORRELATION_COMPARATOR::CLEANUP

    self->abstract_respiratory_signal_comparator::cleanup

END


;; 
;;
FUNCTION RESPIRATORY_SIGNAL_CORRELATION_COMPARATOR::COMPARE, RESPIRATORY_SIGNALS, OFFSETS

    ; get all signals and compare them by correlation
    signal_matrix = self->resample(respiratory_signals, offsets, /truncate)
    return, correlate(signal_matrix, /double)

END
