;; 
;;
PRO RESPIRATORY_SIGNAL_GATED_CORRELATION_COMPARATOR__DEFINE

    ; define the class structure 
    struct = { RESPIRATORY_SIGNAL_GATED_CORRELATION_COMPARATOR, INHERITS abstract_respiratory_signal_gated_comparator }

END


;; 
;;
FUNCTION RESPIRATORY_SIGNAL_GATED_CORRELATION_COMPARATOR::INIT, DURATION=DURATION, GATING_METHOD=GATING_METHOD, NUMBER_OF_GATES=NUMBER_OF_GATES

    if (~self->abstract_respiratory_signal_gated_comparator::init(duration=duration, gating_method=gating_method, number_of_gates=number_of_gates)) then begin
        return, 0
    endif

    return, 1

END



;;
;;
PRO RESPIRATORY_SIGNAL_GATED_CORRELATION_COMPARATOR::CLEANUP

    self->abstract_respiratory_signal_gated_comparator::cleanup

END


;; 
;;
FUNCTION RESPIRATORY_SIGNAL_GATED_CORRELATION_COMPARATOR::COMPARE, RESPIRATORY_SIGNALS, OFFSETS

    ; get all gated signals and compare them by correlation
    gates_matrix = self->gate(respiratory_signals, offsets)
    return, correlate(gates_matrix, /double)

END
