;; 
;;
PRO TOTAL_SUM_FILTER__DEFINE

    ; define the class structure 
    struct = { TOTAL_SUM_FILTER, INHERITS signal_filter }

END


;; Creates new Body Motion Filter.
;;
FUNCTION TOTAL_SUM_FILTER::INIT, SAMPLING_TIME=SAMPLING_TIME, MULTIPLEX_DIMENSION=MULTIPLEX_DIMENSION

    return, self->signal_filter::init(sampling_time=sampling_time, multiplex_dimension=multiplex_dimension)

END


;; 
;;
PRO TOTAL_SUM_FILTER::CLEANUP

    self->signal_filter::cleanup

END


;;
;;
FUNCTION TOTAL_SUM_FILTER::APPLY, DATA

    n_data = n_elements(data)
    total = total(data)
    return, rebin([total], n_data)

END
